Attribute VB_Name = "Module_UrlToFile"
Option Explicit
'############################################################################################
    Private Const INTERNET_OPEN_TYPE_PRECONFIG = 0
    Private Const INTERNET_OPEN_TYPE_DIRECT = 1
    Private Const INTERNET_OPEN_TYPE_PROXY = 3

    Private Const scUserAgent = "VB OpenUrl"
    Private Const INTERNET_FLAG_RELOAD = &H80000000
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Private Declare Function InternetOpen Lib "wininet.dll" _
        Alias "InternetOpenA" _
       (ByVal sAgent As String, _
        ByVal lAccessType As Long, _
        ByVal sProxyName As String, _
        ByVal sProxyBypass As String, _
        ByVal lFlags As Long) _
        As Long
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Private Declare Function InternetOpenUrl Lib "wininet.dll" _
        Alias "InternetOpenUrlA" _
       (ByVal hOpen As Long, _
        ByVal sUrl As String, _
        ByVal sHeaders As String, _
        ByVal lLength As Long, _
        ByVal lFlags As Long, _
        ByVal lContext As Long) _
        As Long
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Private Declare Function InternetReadFile Lib "wininet.dll" _
       (ByVal hFile As Long, _
        ByVal sBuffer As String, _
        ByVal lNumBytesToRead As Long, _
        lNumberOfBytesRead As Long) _
        As Integer
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Private Declare Function InternetCloseHandle Lib "wininet.dll" _
       (ByVal hInet As Long) _
        As Integer
'############################################################################################
Public Function GetUrlToString(sUrl As String) As String
    Dim S As String
    Dim hOpen As Long
    Dim hOpenUrl As Long
    Dim bDoLoop As Boolean
    Dim bRet As Boolean
    Dim sReadBuffer As String * 2048
    Dim lNumberOfBytesRead As Long
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    hOpen = InternetOpen(scUserAgent, INTERNET_OPEN_TYPE_PRECONFIG, vbNullString, vbNullString, 0)
    hOpenUrl = InternetOpenUrl(hOpen, sUrl, vbNullString, ByVal 0&, INTERNET_FLAG_RELOAD, ByVal 0&)
    bDoLoop = True
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    While bDoLoop
        sReadBuffer = vbNullString
        bRet = InternetReadFile(hOpenUrl, sReadBuffer, Len(sReadBuffer), lNumberOfBytesRead)
        S = S & Left$(sReadBuffer, lNumberOfBytesRead)
        If Not CBool(lNumberOfBytesRead) Then bDoLoop = False
    Wend
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    If hOpenUrl <> 0 Then InternetCloseHandle (hOpenUrl)
    If hOpen <> 0 Then InternetCloseHandle (hOpen)
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    GetUrlToString = S
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
End Function
'############################################################################################
Public Function GetUrlToFile(sUrl As String, sPath As String) As Long
'Preserves pre-existing sPath if download fails....
    Dim S As String
    Dim hOpen As Long
    Dim hOpenUrl As Long
    Dim bDoLoop As Boolean
    Dim bRet As Boolean
    Dim sReadBuffer As String * 2048
    Dim lNumberOfBytesRead As Long
    Dim n As Integer
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    hOpen = InternetOpen(scUserAgent, INTERNET_OPEN_TYPE_PRECONFIG, vbNullString, vbNullString, 0)
    hOpenUrl = InternetOpenUrl(hOpen, sUrl, vbNullString, ByVal 0&, INTERNET_FLAG_RELOAD, ByVal 0&)
    bDoLoop = True
    If ((hOpen <> 0) And (hOpenUrl <> 0) And (Dir(sPath) <> "")) Then Kill sPath
    n = FreeFile
    Open sPath For Binary Access Write As #n
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    While bDoLoop
        sReadBuffer = vbNullString
        bRet = InternetReadFile(hOpenUrl, sReadBuffer, Len(sReadBuffer), lNumberOfBytesRead)
        'MsgBox bRet & vbLf & lNumberOfBytesRead & vbCrLf & sReadBuffer
        S = Left$(sReadBuffer, lNumberOfBytesRead)
        GetUrlToFile = GetUrlToFile + lNumberOfBytesRead
        Put #n, , S
        If Not CBool(lNumberOfBytesRead) Then bDoLoop = False
    Wend
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    Close #n
    If hOpenUrl <> 0 Then InternetCloseHandle (hOpenUrl)
    If hOpen <> 0 Then InternetCloseHandle (hOpen)
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
End Function
'############################################################################################
Public Sub LfToCrLf(sPath As String, Optional lFileLOF, Optional lFileLEN)
    Dim fn As String
    Dim n As Integer
    Dim sWWW As String
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    lFileLOF = 0
    lFileLEN = 0
    fn = sPath
    n = FreeFile
    Open fn For Input As #n
    If (LOF(n) = 0) Then MsgBox sPath, vbCritical: GoTo EndEnd
    Line Input #n, sWWW
    lFileLOF = LOF(n)
    lFileLEN = Len(sWWW)
    'MsgBox sPath & vbCrLf & lFileLOF & vbCrLf & lFileLEN
    If (Len(sWWW) > 200) Then
        Close #n
        sWWW = Replace(sWWW, vbLf, vbCrLf)
        Kill sPath
        Open sPath For Binary As #n
        Put #n, , sWWW
    End If
EndEnd:
    Close #n
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
End Sub
'############################################################################################

